theory Compiler = Main:

types 'v binop = "'v => 'v => 'v"

datatype ('a,'v) expr = Cex 'v
  | Vex 'a
  | Bex "'v binop" "('a, 'v) expr" "('a,'v) expr"

thm expr.induct
thm expr.inject
thm expr.distinct
  

consts value :: "('a,'v) expr => ('a => 'v) => 'v"

primrec
  "value (Cex v) env = v"
  "value (Vex a) env = env a"
  "value (Bex f e1 e2) env = f (value e1 env) (value e2 env)"

datatype ('a, 'v) instr = Const 'v
  | Load 'a
  | Apply "'v binop"


consts exec :: "('a,'v) instr list => ('a => 'v) => 'v list => 'v list"
thm instr.cases
primrec
  "exec [] s vs = vs"
  "exec (i#is) s vs  = (case i of
	Const v => exec is s (v # vs) 
	| Load a => exec is s ((s a) # vs) 
	| Apply f => exec is s ((f (hd vs) (hd (tl vs))) # (tl (tl vs))) )"

consts comp :: "('a, 'v) expr => ('a, 'v) instr list "

primrec
  "comp (Cex v) = [Const v ]"
  "comp (Vex a) = [Load a]"
  "comp (Bex f e1 e2) = comp e2 @ comp e1 @ [Apply f]"

end
  



